// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package rpc

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// WorkerClient is the client API for Worker service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type WorkerClient interface {
	Map(ctx context.Context, in *MapInfo, opts ...grpc.CallOption) (*Result, error)
	Reduce(ctx context.Context, in *ReduceInfo, opts ...grpc.CallOption) (*Result, error)
	// IMD = InterMeDiate
	GetIMDData(ctx context.Context, in *IMDLoc, opts ...grpc.CallOption) (*JSONKVs, error)
	// rpc HealthCheck (IMDInfo) returns (UpdateResult);
	End(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*Empty, error)
	Health(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*WorkerState, error)
}

type workerClient struct {
	cc grpc.ClientConnInterface
}

func NewWorkerClient(cc grpc.ClientConnInterface) WorkerClient {
	return &workerClient{cc}
}

func (c *workerClient) Map(ctx context.Context, in *MapInfo, opts ...grpc.CallOption) (*Result, error) {
	out := new(Result)
	err := c.cc.Invoke(ctx, "/Worker/Map", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *workerClient) Reduce(ctx context.Context, in *ReduceInfo, opts ...grpc.CallOption) (*Result, error) {
	out := new(Result)
	err := c.cc.Invoke(ctx, "/Worker/Reduce", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *workerClient) GetIMDData(ctx context.Context, in *IMDLoc, opts ...grpc.CallOption) (*JSONKVs, error) {
	out := new(JSONKVs)
	err := c.cc.Invoke(ctx, "/Worker/GetIMDData", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *workerClient) End(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*Empty, error) {
	out := new(Empty)
	err := c.cc.Invoke(ctx, "/Worker/End", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *workerClient) Health(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*WorkerState, error) {
	out := new(WorkerState)
	err := c.cc.Invoke(ctx, "/Worker/Health", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// WorkerServer is the server API for Worker service.
// All implementations must embed UnimplementedWorkerServer
// for forward compatibility
type WorkerServer interface {
	Map(context.Context, *MapInfo) (*Result, error)
	Reduce(context.Context, *ReduceInfo) (*Result, error)
	// IMD = InterMeDiate
	GetIMDData(context.Context, *IMDLoc) (*JSONKVs, error)
	// rpc HealthCheck (IMDInfo) returns (UpdateResult);
	End(context.Context, *Empty) (*Empty, error)
	Health(context.Context, *Empty) (*WorkerState, error)
	mustEmbedUnimplementedWorkerServer()
}

// UnimplementedWorkerServer must be embedded to have forward compatible implementations.
type UnimplementedWorkerServer struct {
}

func (UnimplementedWorkerServer) Map(context.Context, *MapInfo) (*Result, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Map not implemented")
}
func (UnimplementedWorkerServer) Reduce(context.Context, *ReduceInfo) (*Result, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Reduce not implemented")
}
func (UnimplementedWorkerServer) GetIMDData(context.Context, *IMDLoc) (*JSONKVs, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetIMDData not implemented")
}
func (UnimplementedWorkerServer) End(context.Context, *Empty) (*Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method End not implemented")
}
func (UnimplementedWorkerServer) Health(context.Context, *Empty) (*WorkerState, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Health not implemented")
}
func (UnimplementedWorkerServer) mustEmbedUnimplementedWorkerServer() {}

// UnsafeWorkerServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to WorkerServer will
// result in compilation errors.
type UnsafeWorkerServer interface {
	mustEmbedUnimplementedWorkerServer()
}

func RegisterWorkerServer(s grpc.ServiceRegistrar, srv WorkerServer) {
	s.RegisterService(&Worker_ServiceDesc, srv)
}

func _Worker_Map_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MapInfo)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WorkerServer).Map(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Worker/Map",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WorkerServer).Map(ctx, req.(*MapInfo))
	}
	return interceptor(ctx, in, info, handler)
}

func _Worker_Reduce_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ReduceInfo)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WorkerServer).Reduce(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Worker/Reduce",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WorkerServer).Reduce(ctx, req.(*ReduceInfo))
	}
	return interceptor(ctx, in, info, handler)
}

func _Worker_GetIMDData_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(IMDLoc)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WorkerServer).GetIMDData(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Worker/GetIMDData",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WorkerServer).GetIMDData(ctx, req.(*IMDLoc))
	}
	return interceptor(ctx, in, info, handler)
}

func _Worker_End_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WorkerServer).End(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Worker/End",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WorkerServer).End(ctx, req.(*Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Worker_Health_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(WorkerServer).Health(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/Worker/Health",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(WorkerServer).Health(ctx, req.(*Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// Worker_ServiceDesc is the grpc.ServiceDesc for Worker service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Worker_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "Worker",
	HandlerType: (*WorkerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Map",
			Handler:    _Worker_Map_Handler,
		},
		{
			MethodName: "Reduce",
			Handler:    _Worker_Reduce_Handler,
		},
		{
			MethodName: "GetIMDData",
			Handler:    _Worker_GetIMDData_Handler,
		},
		{
			MethodName: "End",
			Handler:    _Worker_End_Handler,
		},
		{
			MethodName: "Health",
			Handler:    _Worker_Health_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "rpc/worker.proto",
}
